<html>
<head>
<title>Ogre::RTShader::GLSLESProgramWriter Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="namespaceOgre_1_1RTShader.html">RTShader</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html">GLSLESProgramWriter</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="#pro-types">Protected Types</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::RTShader::GLSLESProgramWriter Class Reference<div class="ingroups"><a class="el" href="group__RTShader.html">RTShader</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::RTShader::GLSLESProgramWriter" --><!-- doxytag: inherits="Ogre::RTShader::ProgramWriter" -->
<p>GLSL ES target language writer implementation.  
 <a href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::RTShader::GLSLESProgramWriter:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1RTShader_1_1GLSLESProgramWriter__inherit__graph.gif" border="0" usemap="#Ogre_1_1RTShader_1_1GLSLESProgramWriter_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1RTShader_1_1GLSLESProgramWriter_inherit__map" id="Ogre_1_1RTShader_1_1GLSLESProgramWriter_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1RTShader_1_1ProgramWriter.html" title="Base class interface for shader program writers." alt="" coords="31,83,239,112"/><area shape="rect" id="node4" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="57,5,212,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1RTShader_1_1GLSLESProgramWriter-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a6476d951d9c0ee8bb85d0b490e74300e">GLSLESProgramWriter</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class constructor.  <a href="#a6476d951d9c0ee8bb85d0b490e74300e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a12c7055a4aa2015c33d1efcba52a74da">~GLSLESProgramWriter</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class destructor.  <a href="#a12c7055a4aa2015c33d1efcba52a74da"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a87e5c1203bdc1fafb5ca3be4636e5e32">writeSourceCode</a> (<a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *program)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a314654f81c05e2b12e1e4d627e2787f5">getTargetLanguage</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a837e41776125868b35313319357568b4">TargetLanguage</a></td></tr>
<tr><td colspan="2"><h2><a name="pro-types"></a>
Protected Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef std::map<br class="typebreak"/>
&lt; <a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">GpuConstantType</a>, const char * &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a838982f222ed894ba885138d387f6457">GpuConstTypeToStringMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef std::map<br class="typebreak"/>
&lt; <a class="el" href="classOgre_1_1RTShader_1_1Parameter.html#a91fc3614f191bebf0461676a03750312">Parameter::Semantic</a>, const <br class="typebreak"/>
char * &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a5425d7e653d60cc425a00970cbdd3435">ParamSemanticToStringMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef std::map<br class="typebreak"/>
&lt; <a class="el" href="classOgre_1_1RTShader_1_1Parameter.html#a4fa6286f097d19e92a8ed91645fbfbe7">Parameter::Content</a>, const <br class="typebreak"/>
char * &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a2357acbe954b81591250f983d41a27bd">ParamContentToStringMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef std::map&lt; <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#afb88c31bd9a836837108865ab55817e2">StringMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef std::map<br class="typebreak"/>
&lt; <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html">FunctionInvocation</a>, <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#afd2e9db0b7809b6f676f10dfb5776baa">FunctionMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef std::vector<br class="typebreak"/>
&lt; <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html">FunctionInvocation</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a91d46a7e8bc9a95643494ae15908cc06">FunctionVector</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef FunctionMap::const_iterator&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a4bbd352818d0e9a370658c3dd46b53d6">FunctionMapIterator</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <br class="typebreak"/>
FunctionVector::const_iterator&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a679ccd9ab1ce495e759675534c3b6568">FunctionVectorIterator</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <br class="typebreak"/>
GpuConstTypeToStringMap::const_iterator&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a800ca3e3f67302866f7901491b4e8a94">GpuConstTypeToStringMapIterator</a></td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a7bcd6a3f3d32a4c0f618b843806c3409">initializeStringMaps</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize string maps.  <a href="#a7bcd6a3f3d32a4c0f618b843806c3409"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a746a27ed72bbf45e930dbc34d180d09e">cacheDependencyFunctions</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;libName)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Cache functions of a dependency.  <a href="#a746a27ed72bbf45e930dbc34d180d09e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html">FunctionInvocation</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a7681f909aa467939c4c34db9c8b436d1">createInvocationFromString</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;input)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html" title="A class that represents function invocation code from shader based program function.">FunctionInvocation</a> object from a string taken out of a shader library.  <a href="#a7681f909aa467939c4c34db9c8b436d1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a80f56e3ca546c366b0d9cb5303043239">writeProgramDependencies</a> (<a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *program)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the program dependencies.  <a href="#a80f56e3ca546c366b0d9cb5303043239"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#abef9adf83addddd76b1836cc971eee1a">writeLocalParameter</a> (<a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;os, <a class="el" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a> parameter)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write a local parameter.  <a href="#abef9adf83addddd76b1836cc971eee1a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a12e1a4545a050fcae65e3eba7e3252c0">writeInputParameters</a> (<a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *function, <a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a> gpuType)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the input params of the function.  <a href="#a12e1a4545a050fcae65e3eba7e3252c0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a9362f13819d3e0ea24e8764fe611cb1f">writeOutParameters</a> (<a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *function, <a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a> gpuType)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the output params of the function.  <a href="#a9362f13819d3e0ea24e8764fe611cb1f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#aee0e2df004d5e7d2c5e312f180b336ee">writeAssignFunction</a> (<a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;os, FunctionInvocation::OperandVector::iterator itOperand, FunctionInvocation::OperandVector::iterator itOperandEnd, <a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a> gpuType)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a879358138a4325ca23065cf454829e11">processOperand</a> (<a class="el" href="classOgre_1_1RTShader_1_1Operand.html">Operand</a> op, <a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a> gpuType)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a0fdbf3067b64c149dee82c7c11ecd161">isBasicType</a> (<a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;type)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Check if a string matches one of the GLSL ES basic types.  <a href="#a0fdbf3067b64c149dee82c7c11ecd161"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a1fb686334668dd6a3cf729e6446d5ac1">discoverFunctionDependencies</a> (const <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html">FunctionInvocation</a> &amp;invoc, <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a91d46a7e8bc9a95643494ae15908cc06">FunctionVector</a> &amp;depVector)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Search within a function body for non-builtin functions that a given function invocation depends on.  <a href="#a1fb686334668dd6a3cf729e6446d5ac1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#ab1b6c67defa74dfdce8a0bcd1ccb62cb">writeProgramTitle</a> (<a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *program)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the program title.  <a href="#ab1b6c67defa74dfdce8a0bcd1ccb62cb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#a9503345c6d319c8c39cdb1f8c83f10a0">writeUniformParametersTitle</a> (<a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *program)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the uniform parameters title.  <a href="#a9503345c6d319c8c39cdb1f8c83f10a0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#a6417dc1c4838e8df26e98b3c675ec26f">writeFunctionTitle</a> (<a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *function)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write a function title.  <a href="#a6417dc1c4838e8df26e98b3c675ec26f"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a838982f222ed894ba885138d387f6457">GpuConstTypeToStringMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a5ada74c1fe3817cec67e8f6a10a186a7">mGpuConstTypeMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a5425d7e653d60cc425a00970cbdd3435">ParamSemanticToStringMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a97bb9afd75a1d22ddbcb5f10e07387f7">mParamSemanticMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#afb88c31bd9a836837108865ab55817e2">StringMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a072bb41a8bfb1269eabb78b8e4677026">mInputToGLStatesMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#afd2e9db0b7809b6f676f10dfb5776baa">FunctionMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#ad4c61befd054220be587d8ef09238d8c">mFunctionCacheMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#afb88c31bd9a836837108865ab55817e2">StringMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a864563e76ac05d24f3d96327f94ac8b7">mDefinesMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a2357acbe954b81591250f983d41a27bd">ParamContentToStringMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a520dea173b0e00ae96c56b2354cead90">mContentToPerVertexAttributes</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a34feadf754410c6f87d0b618507ab61d">mGLSLVersion</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#ae6f17f7fe43510fdbddb1e17c844d0dc">mFragInputParams</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#afb88c31bd9a836837108865ab55817e2">StringMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a8eb977d474ffb205906396cced806bb7">mCachedFunctionLibraries</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>GLSL ES target language writer implementation. </p>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html" title="Base class interface for shader program writers.">ProgramWriter</a>. </dd></dl>

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00045">45</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="afd2e9db0b7809b6f676f10dfb5776baa"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::FunctionMap" ref="afd2e9db0b7809b6f676f10dfb5776baa" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::map&lt;<a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html">FunctionInvocation</a>, <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&gt; <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#afd2e9db0b7809b6f676f10dfb5776baa">Ogre::RTShader::GLSLESProgramWriter::FunctionMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00080">80</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4bbd352818d0e9a370658c3dd46b53d6"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::FunctionMapIterator" ref="a4bbd352818d0e9a370658c3dd46b53d6" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef FunctionMap::const_iterator <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a4bbd352818d0e9a370658c3dd46b53d6">Ogre::RTShader::GLSLESProgramWriter::FunctionMapIterator</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00082">82</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a91d46a7e8bc9a95643494ae15908cc06"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::FunctionVector" ref="a91d46a7e8bc9a95643494ae15908cc06" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html">FunctionInvocation</a>&gt; <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a91d46a7e8bc9a95643494ae15908cc06">Ogre::RTShader::GLSLESProgramWriter::FunctionVector</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00081">81</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a679ccd9ab1ce495e759675534c3b6568"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::FunctionVectorIterator" ref="a679ccd9ab1ce495e759675534c3b6568" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef FunctionVector::const_iterator <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a679ccd9ab1ce495e759675534c3b6568">Ogre::RTShader::GLSLESProgramWriter::FunctionVectorIterator</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00083">83</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a838982f222ed894ba885138d387f6457"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::GpuConstTypeToStringMap" ref="a838982f222ed894ba885138d387f6457" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::map&lt;<a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">GpuConstantType</a>, const char*&gt; <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a838982f222ed894ba885138d387f6457">Ogre::RTShader::GLSLESProgramWriter::GpuConstTypeToStringMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00076">76</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a800ca3e3f67302866f7901491b4e8a94"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::GpuConstTypeToStringMapIterator" ref="a800ca3e3f67302866f7901491b4e8a94" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef GpuConstTypeToStringMap::const_iterator <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a800ca3e3f67302866f7901491b4e8a94">Ogre::RTShader::GLSLESProgramWriter::GpuConstTypeToStringMapIterator</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00084">84</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a2357acbe954b81591250f983d41a27bd"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::ParamContentToStringMap" ref="a2357acbe954b81591250f983d41a27bd" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::map&lt;<a class="el" href="classOgre_1_1RTShader_1_1Parameter.html#a4fa6286f097d19e92a8ed91645fbfbe7">Parameter::Content</a>, const char*&gt; <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a2357acbe954b81591250f983d41a27bd">Ogre::RTShader::GLSLESProgramWriter::ParamContentToStringMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00078">78</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a5425d7e653d60cc425a00970cbdd3435"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::ParamSemanticToStringMap" ref="a5425d7e653d60cc425a00970cbdd3435" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::map&lt;<a class="el" href="classOgre_1_1RTShader_1_1Parameter.html#a91fc3614f191bebf0461676a03750312">Parameter::Semantic</a>, const char*&gt; <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a5425d7e653d60cc425a00970cbdd3435">Ogre::RTShader::GLSLESProgramWriter::ParamSemanticToStringMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00077">77</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="afb88c31bd9a836837108865ab55817e2"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::StringMap" ref="afb88c31bd9a836837108865ab55817e2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::map&lt;<a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&gt; <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#afb88c31bd9a836837108865ab55817e2">Ogre::RTShader::GLSLESProgramWriter::StringMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00079">79</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a6476d951d9c0ee8bb85d0b490e74300e"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::GLSLESProgramWriter" ref="a6476d951d9c0ee8bb85d0b490e74300e" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a6476d951d9c0ee8bb85d0b490e74300e">Ogre::RTShader::GLSLESProgramWriter::GLSLESProgramWriter</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class constructor. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">language</td><td>The target shader language. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a12c7055a4aa2015c33d1efcba52a74da"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::~GLSLESProgramWriter" ref="a12c7055a4aa2015c33d1efcba52a74da" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a12c7055a4aa2015c33d1efcba52a74da">Ogre::RTShader::GLSLESProgramWriter::~GLSLESProgramWriter</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class destructor. </p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a746a27ed72bbf45e930dbc34d180d09e"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::cacheDependencyFunctions" ref="a746a27ed72bbf45e930dbc34d180d09e" args="(const String &amp;libName)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a746a27ed72bbf45e930dbc34d180d09e">Ogre::RTShader::GLSLESProgramWriter::cacheDependencyFunctions</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>libName</em></td><td>)</td>
          <td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Cache functions of a dependency. </p>

</div>
</div>
<a class="anchor" id="a7681f909aa467939c4c34db9c8b436d1"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::createInvocationFromString" ref="a7681f909aa467939c4c34db9c8b436d1" args="(const String &amp;input)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html">FunctionInvocation</a>* <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a7681f909aa467939c4c34db9c8b436d1">Ogre::RTShader::GLSLESProgramWriter::createInvocationFromString</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>input</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html" title="A class that represents function invocation code from shader based program function.">FunctionInvocation</a> object from a string taken out of a shader library. </p>

</div>
</div>
<a class="anchor" id="a1fb686334668dd6a3cf729e6446d5ac1"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::discoverFunctionDependencies" ref="a1fb686334668dd6a3cf729e6446d5ac1" args="(const FunctionInvocation &amp;invoc, FunctionVector &amp;depVector)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a1fb686334668dd6a3cf729e6446d5ac1">Ogre::RTShader::GLSLESProgramWriter::discoverFunctionDependencies</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html">FunctionInvocation</a> &amp;&#160;</td>
          <td class="paramname"><em>invoc</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a91d46a7e8bc9a95643494ae15908cc06">FunctionVector</a> &amp;&#160;</td>
          <td class="paramname"><em>depVector</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Search within a function body for non-builtin functions that a given function invocation depends on. </p>

</div>
</div>
<a class="anchor" id="a314654f81c05e2b12e1e4d627e2787f5"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::getTargetLanguage" ref="a314654f81c05e2b12e1e4d627e2787f5" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a314654f81c05e2b12e1e4d627e2787f5">Ogre::RTShader::GLSLESProgramWriter::getTargetLanguage</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#adea123814282cb2fd21f504246647b06" title="Return the target language of this writer.">ProgramWriter::getTargetLanguage</a>. </dd></dl>

<p>Implements <a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#adea123814282cb2fd21f504246647b06">Ogre::RTShader::ProgramWriter</a>.</p>

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00071">71</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>

<p>References <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00073">TargetLanguage</a>.</p>

</div>
</div>
<a class="anchor" id="a7bcd6a3f3d32a4c0f618b843806c3409"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::initializeStringMaps" ref="a7bcd6a3f3d32a4c0f618b843806c3409" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a7bcd6a3f3d32a4c0f618b843806c3409">Ogre::RTShader::GLSLESProgramWriter::initializeStringMaps</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Initialize string maps. </p>

</div>
</div>
<a class="anchor" id="a0fdbf3067b64c149dee82c7c11ecd161"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::isBasicType" ref="a0fdbf3067b64c149dee82c7c11ecd161" args="(String &amp;type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a0fdbf3067b64c149dee82c7c11ecd161">Ogre::RTShader::GLSLESProgramWriter::isBasicType</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>type</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Check if a string matches one of the GLSL ES basic types. </p>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a879358138a4325ca23065cf454829e11"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::processOperand" ref="a879358138a4325ca23065cf454829e11" args="(Operand op, GpuProgramType gpuType)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a879358138a4325ca23065cf454829e11">Ogre::RTShader::GLSLESProgramWriter::processOperand</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html">Operand</a>&#160;</td>
          <td class="paramname"><em>op</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a>&#160;</td>
          <td class="paramname"><em>gpuType</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="aee0e2df004d5e7d2c5e312f180b336ee"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::writeAssignFunction" ref="aee0e2df004d5e7d2c5e312f180b336ee" args="(StringSerialiser &amp;os, FunctionInvocation::OperandVector::iterator itOperand, FunctionInvocation::OperandVector::iterator itOperandEnd, GpuProgramType gpuType)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#aee0e2df004d5e7d2c5e312f180b336ee">Ogre::RTShader::GLSLESProgramWriter::writeAssignFunction</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">FunctionInvocation::OperandVector::iterator&#160;</td>
          <td class="paramname"><em>itOperand</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">FunctionInvocation::OperandVector::iterator&#160;</td>
          <td class="paramname"><em>itOperandEnd</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a>&#160;</td>
          <td class="paramname"><em>gpuType</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a6417dc1c4838e8df26e98b3c675ec26f"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::writeFunctionTitle" ref="a6417dc1c4838e8df26e98b3c675ec26f" args="(StringSerialiser &amp;os, Function *function)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#a6417dc1c4838e8df26e98b3c675ec26f">Ogre::RTShader::ProgramWriter::writeFunctionTitle</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *&#160;</td>
          <td class="paramname"><em>function</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write a function title. </p>

</div>
</div>
<a class="anchor" id="a12e1a4545a050fcae65e3eba7e3252c0"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::writeInputParameters" ref="a12e1a4545a050fcae65e3eba7e3252c0" args="(StringSerialiser &amp;os, Function *function, GpuProgramType gpuType)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a12e1a4545a050fcae65e3eba7e3252c0">Ogre::RTShader::GLSLESProgramWriter::writeInputParameters</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *&#160;</td>
          <td class="paramname"><em>function</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a>&#160;</td>
          <td class="paramname"><em>gpuType</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write the input params of the function. </p>

</div>
</div>
<a class="anchor" id="abef9adf83addddd76b1836cc971eee1a"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::writeLocalParameter" ref="abef9adf83addddd76b1836cc971eee1a" args="(StringSerialiser &amp;os, ParameterPtr parameter)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#abef9adf83addddd76b1836cc971eee1a">Ogre::RTShader::GLSLESProgramWriter::writeLocalParameter</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>&#160;</td>
          <td class="paramname"><em>parameter</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write a local parameter. </p>

</div>
</div>
<a class="anchor" id="a9362f13819d3e0ea24e8764fe611cb1f"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::writeOutParameters" ref="a9362f13819d3e0ea24e8764fe611cb1f" args="(StringSerialiser &amp;os, Function *function, GpuProgramType gpuType)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a9362f13819d3e0ea24e8764fe611cb1f">Ogre::RTShader::GLSLESProgramWriter::writeOutParameters</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *&#160;</td>
          <td class="paramname"><em>function</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a>&#160;</td>
          <td class="paramname"><em>gpuType</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write the output params of the function. </p>

</div>
</div>
<a class="anchor" id="a80f56e3ca546c366b0d9cb5303043239"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::writeProgramDependencies" ref="a80f56e3ca546c366b0d9cb5303043239" args="(StringSerialiser &amp;os, Program *program)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a80f56e3ca546c366b0d9cb5303043239">Ogre::RTShader::GLSLESProgramWriter::writeProgramDependencies</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *&#160;</td>
          <td class="paramname"><em>program</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write the program dependencies. </p>

</div>
</div>
<a class="anchor" id="ab1b6c67defa74dfdce8a0bcd1ccb62cb"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::writeProgramTitle" ref="ab1b6c67defa74dfdce8a0bcd1ccb62cb" args="(StringSerialiser &amp;os, Program *program)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#ab1b6c67defa74dfdce8a0bcd1ccb62cb">Ogre::RTShader::ProgramWriter::writeProgramTitle</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *&#160;</td>
          <td class="paramname"><em>program</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write the program title. </p>

</div>
</div>
<a class="anchor" id="a87e5c1203bdc1fafb5ca3be4636e5e32"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::writeSourceCode" ref="a87e5c1203bdc1fafb5ca3be4636e5e32" args="(StringSerialiser &amp;os, Program *program)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a87e5c1203bdc1fafb5ca3be4636e5e32">Ogre::RTShader::GLSLESProgramWriter::writeSourceCode</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *&#160;</td>
          <td class="paramname"><em>program</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#a2dedd0d346cf93b37f379e35775d4e20" title="Write the program shader source code.">ProgramWriter::writeSourceCode</a>. </dd></dl>

<p>Implements <a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#a2dedd0d346cf93b37f379e35775d4e20">Ogre::RTShader::ProgramWriter</a>.</p>

</div>
</div>
<a class="anchor" id="a9503345c6d319c8c39cdb1f8c83f10a0"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::writeUniformParametersTitle" ref="a9503345c6d319c8c39cdb1f8c83f10a0" args="(StringSerialiser &amp;os, Program *program)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#a9503345c6d319c8c39cdb1f8c83f10a0">Ogre::RTShader::ProgramWriter::writeUniformParametersTitle</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *&#160;</td>
          <td class="paramname"><em>program</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write the uniform parameters title. </p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a8eb977d474ffb205906396cced806bb7"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::mCachedFunctionLibraries" ref="a8eb977d474ffb205906396cced806bb7" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#afb88c31bd9a836837108865ab55817e2">StringMap</a> <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a8eb977d474ffb205906396cced806bb7">Ogre::RTShader::GLSLESProgramWriter::mCachedFunctionLibraries</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00152">152</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a520dea173b0e00ae96c56b2354cead90"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::mContentToPerVertexAttributes" ref="a520dea173b0e00ae96c56b2354cead90" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a2357acbe954b81591250f983d41a27bd">ParamContentToStringMap</a> <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a520dea173b0e00ae96c56b2354cead90">Ogre::RTShader::GLSLESProgramWriter::mContentToPerVertexAttributes</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00149">149</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a864563e76ac05d24f3d96327f94ac8b7"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::mDefinesMap" ref="a864563e76ac05d24f3d96327f94ac8b7" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#afb88c31bd9a836837108865ab55817e2">StringMap</a> <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a864563e76ac05d24f3d96327f94ac8b7">Ogre::RTShader::GLSLESProgramWriter::mDefinesMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00148">148</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="ae6f17f7fe43510fdbddb1e17c844d0dc"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::mFragInputParams" ref="ae6f17f7fe43510fdbddb1e17c844d0dc" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a> <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#ae6f17f7fe43510fdbddb1e17c844d0dc">Ogre::RTShader::GLSLESProgramWriter::mFragInputParams</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00151">151</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="ad4c61befd054220be587d8ef09238d8c"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::mFunctionCacheMap" ref="ad4c61befd054220be587d8ef09238d8c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#afd2e9db0b7809b6f676f10dfb5776baa">FunctionMap</a> <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#ad4c61befd054220be587d8ef09238d8c">Ogre::RTShader::GLSLESProgramWriter::mFunctionCacheMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00147">147</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a34feadf754410c6f87d0b618507ab61d"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::mGLSLVersion" ref="a34feadf754410c6f87d0b618507ab61d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a34feadf754410c6f87d0b618507ab61d">Ogre::RTShader::GLSLESProgramWriter::mGLSLVersion</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00150">150</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a5ada74c1fe3817cec67e8f6a10a186a7"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::mGpuConstTypeMap" ref="a5ada74c1fe3817cec67e8f6a10a186a7" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a838982f222ed894ba885138d387f6457">GpuConstTypeToStringMap</a> <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a5ada74c1fe3817cec67e8f6a10a186a7">Ogre::RTShader::GLSLESProgramWriter::mGpuConstTypeMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00143">143</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a072bb41a8bfb1269eabb78b8e4677026"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::mInputToGLStatesMap" ref="a072bb41a8bfb1269eabb78b8e4677026" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#afb88c31bd9a836837108865ab55817e2">StringMap</a> <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a072bb41a8bfb1269eabb78b8e4677026">Ogre::RTShader::GLSLESProgramWriter::mInputToGLStatesMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00146">146</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a97bb9afd75a1d22ddbcb5f10e07387f7"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::mParamSemanticMap" ref="a97bb9afd75a1d22ddbcb5f10e07387f7" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a5425d7e653d60cc425a00970cbdd3435">ParamSemanticToStringMap</a> <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a97bb9afd75a1d22ddbcb5f10e07387f7">Ogre::RTShader::GLSLESProgramWriter::mParamSemanticMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00144">144</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a837e41776125868b35313319357568b4"></a><!-- doxytag: member="Ogre::RTShader::GLSLESProgramWriter::TargetLanguage" ref="a837e41776125868b35313319357568b4" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a837e41776125868b35313319357568b4">Ogre::RTShader::GLSLESProgramWriter::TargetLanguage</a><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00073">73</a> of file <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a>.</p>

<p>Referenced by <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00071">getTargetLanguage()</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html">OgreShaderGLSLESProgramWriter.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:32
</p>
</body>
</html>
